Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 807268 - app-emulation/lxd-4.0.7 - ./.../syscall_wrappers.h: error: conflicting types for close_range; have int(unsigned int, unsigned int,
Summary: app-emulation/lxd-4.0.7 - ./.../syscall_wrappers.h: error: conflicting types ...
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Joonas Niilola
URL:
Whiteboard:
Keywords: PATCH, PullRequest
Depends on:
Blocks: glibc-2.34
  Show dependency tree
 
Reported: 2021-08-09 10:52 UTC by Toralf Förster
Modified: 2021-09-24 08:15 UTC (History)
4 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
emerge-info.txt (emerge-info.txt,17.62 KB, text/plain)
2021-08-09 10:52 UTC, Toralf Förster
Details
app-emulation:lxd-4.0.7:20210808-221327.log (app-emulation:lxd-4.0.7:20210808-221327.log,42.76 KB, text/plain)
2021-08-09 10:52 UTC, Toralf Förster
Details
emerge-history.txt (emerge-history.txt,431.93 KB, text/plain)
2021-08-09 10:52 UTC, Toralf Förster
Details
environment (environment,105.02 KB, text/plain)
2021-08-09 10:52 UTC, Toralf Förster
Details
etc.portage.tar.bz2 (etc.portage.tar.bz2,47.68 KB, application/x-bzip)
2021-08-09 10:52 UTC, Toralf Förster
Details
temp.tar.bz2 (temp.tar.bz2,31.42 KB, application/x-bzip)
2021-08-09 10:52 UTC, Toralf Förster
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Toralf Förster gentoo-dev 2021-08-09 10:52:40 UTC
# github.com/lxc/lxd/shared/idmap
In file included from _dist/src/github.com/lxc/lxd/shared/idmap/shift_linux.go:45:
./../../lxd/include/syscall_wrappers.h:19:19: error: conflicting types for 'close_range'; have 'int(unsigned int,  unsigned int,  unsigned int)'
   19 | static inline int close_range(unsigned int fd, unsigned int max_fd, unsigned int flags)
      |                   ^~~~~~~~~~~
In file included from /usr/include/unistd.h:1205,
                 from _dist/src/github.com/lxc/lxd/shared/idmap/shift_linux.go:36:

  -------------------------------------------------------------------

  This is an unstable amd64 chroot image at a tinderbox (==build bot)
  name: 17.1_no_multilib_systemd-j3-20210804-092108

  -------------------------------------------------------------------

gcc-config -l:
 [1] x86_64-pc-linux-gnu-11.2.0 *
clang version 12.0.1
Target: x86_64-pc-linux-gnu
Thread model: posix
InstalledDir: /usr/lib/llvm/12/bin
/usr/lib/llvm/12
12.0.1
Python 3.9.6
Available Ruby profiles:
  [1]   ruby26 (with Rubygems)
  [2]   ruby30 (with Rubygems) *
Available Rust versions:
  [1]   rust-bin-1.54.0 *
The following VMs are available for generation-2:
*)	AdoptOpenJDK JRE 8.292_p10 [openjdk-jre-bin-8]
Available Java Virtual Machines:
  [1]   openjdk-jre-bin-8  system-vm

The Glorious Glasgow Haskell Compilation System, version 8.10.4

  HEAD of ::gentoo
commit 060d5ac01931a4113a8e9659331242cb043fb5dc
Author: Repository mirror & CI <repomirrorci@gentoo.org>
Date:   Sun Aug 8 21:21:50 2021 +0000

    2021-08-08 21:21:49 UTC

emerge -qpvO app-emulation/lxd
[ebuild  N    ] app-emulation/lxd-4.0.7  USE="ipv6 nls -apparmor -verify-sig"
Comment 1 Toralf Förster gentoo-dev 2021-08-09 10:52:41 UTC
Created attachment 731671 [details]
emerge-info.txt
Comment 2 Toralf Förster gentoo-dev 2021-08-09 10:52:42 UTC
Created attachment 731674 [details]
app-emulation:lxd-4.0.7:20210808-221327.log
Comment 3 Toralf Förster gentoo-dev 2021-08-09 10:52:44 UTC
Created attachment 731677 [details]
emerge-history.txt
Comment 4 Toralf Förster gentoo-dev 2021-08-09 10:52:46 UTC
Created attachment 731680 [details]
environment
Comment 5 Toralf Förster gentoo-dev 2021-08-09 10:52:47 UTC
Created attachment 731683 [details]
etc.portage.tar.bz2
Comment 6 Toralf Förster gentoo-dev 2021-08-09 10:52:48 UTC
Created attachment 731686 [details]
temp.tar.bz2
Comment 7 Sam James archtester gentoo-dev Security 2021-08-11 23:28:28 UTC
Patch from upstream master: https://github.com/lxc/lxd/commit/9a128f32fc277dd0c07bc85c71dc25d123f8a831.

Not clear if anybody has backported it but it should be simple from a glance. Let me know if you need help/turns out not to be!
Comment 8 Joonas Niilola gentoo-dev 2021-08-12 04:45:28 UTC
Thanks, I do have few questions:
1. How close we are to unmasking glibc-2.34? lxd-4.0.7 was just released so I expect a next one will be months away. Then again they usually make a quicker release for big fixes like this. I do see the tracker bug is about ~20 done.

2: Will there be some runtime issues if you compile lxd-4.0.7 with glibc-2.33, then update to glibc-2.34 without recompiling? I.e., does this require a revbump?
Comment 9 Sam James archtester gentoo-dev Security 2021-08-17 22:07:16 UTC
(In reply to Joonas Niilola from comment #8)
> Thanks, I do have few questions:
> 1. How close we are to unmasking glibc-2.34? lxd-4.0.7 was just released so
> I expect a next one will be months away. Then again they usually make a
> quicker release for big fixes like this. I do see the tracker bug is about
> ~20 done.
> 

Not very close, although trying to get stuff w/ patches done so we can focus on the ones where upstream is quiet / bugs need reporting.

It'll be a good while.

> 2: Will there be some runtime issues if you compile lxd-4.0.7 with
> glibc-2.33, then update to glibc-2.34 without recompiling? I.e., does this
> require a revbump?

No, all good there!
Comment 10 Larry the Git Cow gentoo-dev 2021-09-24 08:15:18 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=4d7295038ed9e84cc131b3003b1d103f35fcea50

commit 4d7295038ed9e84cc131b3003b1d103f35fcea50
Author:     Florian Schmaus <flow@gentoo.org>
AuthorDate: 2021-09-24 07:49:57 +0000
Commit:     Florian Schmaus <flow@gentoo.org>
CommitDate: 2021-09-24 08:06:15 +0000

    app-emulation/lxd: backport syscall_wrappers patch, use --syslog
    
    This backports the lxd patch to avoid conflicts with glibc's
    close_range(). Also use --syslog instead of
    --logfile=/var/log/lxd/lxd.log in lxd's systemd service, so that lxd's
    log messages are not logged to a file, but instead to the service's
    journal.
    
    The ebuild also no longer uses a dedicated apparmor service
    file (files/lxd-4.0.0_apparmor.service), but instead patches the
    existing service file if apparmor is used. This avoids maintaining two
    systemd service files.
    
    Also drop the unused autotools eclass.
    
    Closes: https://bugs.gentoo.org/807268
    Closes: https://github.com/gentoo/gentoo/pull/22383
    Signed-off-by: Florian Schmaus <flow@gentoo.org>

 app-emulation/lxd/files/lxd-4.0.7-r1.service       |  20 +++
 ...appers-don-t-conflict-with-glibc-provided.patch |  58 +++++++
 app-emulation/lxd/lxd-4.0.7-r1.ebuild              | 170 +++++++++++++++++++++
 3 files changed, 248 insertions(+)